package util;

import java.io.FileWriter;

import org.apache.commons.math3.stat.StatUtils;

public class ArrayFuns {
	/**
	 * The maximum value in a double array.
	 * 
	 * @param values
	 * @return
	 */
	public static double max(double[] values) {
		return StatUtils.max(values);
	}

	/**
	 * The sum of a double array
	 * 
	 * @param values
	 * @return
	 */
	public static double sum(double[] values) {
		return StatUtils.sum(values);
	}

	/**
	 * return the mean value of a double vector.
	 * @param values
	 * @return
	 */
	public static double mean(double[] values) {
		return StatUtils.mean(values);
	}

	public static void fill(double[][] matrix, double val) {
		for (int i = 0; i < matrix.length; i++)
			for (int j = 0; j < matrix[i].length; j++)
				matrix[i][j] = val;
	}

	public static void copy(double[][] src, double[][] dest) {
		assert src.length <= dest.length;
		assert src[0].length <= dest[0].length;
		for (int i = 0; i < src.length; i++)
			for (int j = 0; j < src[i].length; j++)
				dest[i][j] = src[i][j];
	}

	public static void print(int[][] v) {
		for (int i = 0; i < v.length; i++) {
			for (int j = 0; j < v[i].length; j++) {
				if (j == v[i].length - 1)
					System.out.printf("%d\n", v[i][j]);
				else
					System.out.printf("%d, ", v[i][j]);
			}
		}
	}

	public static void write(int[][] v, String file) {
		try {
			FileWriter fw = new FileWriter(file);
			for (int i = 0; i < v.length; i++) {
				for (int j = 0; j < v[i].length; j++) {
					if (j == v[i].length - 1)
						fw.write(String.format("%d\n", v[i][j]));
					else
						fw.write(String.format("%d, ", v[i][j]));
				}
			}
			fw.flush();
			fw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void print(double[][] v) {
		for (int i = 0; i < v.length; i++) {
			for (int j = 0; j < v[i].length; j++) {
				if (j == v[i].length - 1)
					System.out.printf("%.6f\n", v[i][j]);
				else
					System.out.printf("%.6f, ", v[i][j]);
			}
		}
	}

	public static void write(double[][] v, String file) {
		try {
			FileWriter fw = new FileWriter(file);
			for (int i = 0; i < v.length; i++) {
				for (int j = 0; j < v[i].length; j++) {
					if (j == v[i].length - 1)
						fw.write(String.format("%.6f\n", v[i][j]));
					else
						fw.write(String.format("%.6f, ", v[i][j]));
				}
			}
			fw.flush();
			fw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 
	 * @param v
	 */
	public static void print(int[] v) {
		System.out.printf("[");
		for (int i = 0; i < v.length; i++) {
			if (i == v.length - 1)
				System.out.printf("%d", v[i]);
			else
				System.out.printf("%d, ", v[i]);
		}
		System.out.printf("]\n");
	}

	public static String toString(int[] v) {
		StringBuffer buf = new StringBuffer();
		for (int i = 0; i < v.length; i++) {
			if (i == v.length - 1)
				buf.append(String.format("%d", v[i]));
			else
				buf.append(String.format("%d, ", v[i]));
		}
		return buf.toString();
	}

	/**
	 * 
	 * @param v
	 */
	public static void print(double[] v) {
		System.out.printf("[");
		for (int i = 0; i < v.length; i++) {
			if (i == v.length - 1)
				System.out.printf("%.6f", v[i]);
			else
				System.out.printf("%.6f, ", v[i]);
		}
		System.out.printf("]\n");
	}

	public static void write(double[] v, String file) {
		try {
			FileWriter fw = new FileWriter(file);
			for (int i = 0; i < v.length; i++)
				fw.write(String.format("%.6f\n", v[i]));
			fw.flush();
			fw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static String toString(double[] v) {
		StringBuffer buf = new StringBuffer();
		for (int i = 0; i < v.length; i++) {
			buf.append(String.format("%.6f", v[i]));
			if (i < v.length - 1)
				buf.append(" ");
		}
		return buf.toString();
	}
}
